#include <windows.h>

#include "../include/swr.h"
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

// float𗘗pƂɕKvȑϐ
EXTERN_C int _fltused = 0x9875;

#undef INTERFACE
#define INTERFACE IDirectSoundBuffer
DECLARE_INTERFACE_(IDirectSoundBuffer, IUnknown)   /*dsound.h݂Ȃ̂Ŏb*/
{
public:
	// IUnknown methods
	STDMETHOD(QueryInterface)       (THIS_ REFIID riid, LPVOID *ppvObject) PURE;
	STDMETHOD_(ULONG, AddRef)       (THIS) PURE;
	STDMETHOD_(ULONG, Release)      (THIS) PURE;
    // IDirectSoundBuffer methods
	STDMETHOD(GetCaps)              (THIS_ LPVOID lpDSCaps ) PURE;
    STDMETHOD(GetCurrentPosition)   (THIS_ LPDWORD lpdwCurrentPlayCursor, LPDWORD lpdwCurrentWriteCursor ) PURE;
    STDMETHOD(GetFormat)            (THIS_ LPWAVEFORMATEX lpwfxFormat, DWORD dwSizeAllocated,  LPDWORD pdwSizeWritten) PURE;
    STDMETHOD(GetVolume)            (THIS_ LPLONG lplVolume ) PURE;
    STDMETHOD(GetPan)               (THIS_ LPLONG lplPan) PURE;
    STDMETHOD(GetFrequency)         (THIS_ LPDWORD lpdwFrequency ) PURE;
    STDMETHOD(GetStatus)            (THIS_ LPDWORD lpdwStatus ) PURE;
    STDMETHOD(Initialize)           (THIS_ LPVOID lpDirectSound,  LPVOID lpcDSBufferDesc ) PURE;
    STDMETHOD(Lock)                 (THIS_ DWORD dwWriteCursor,   DWORD dwWriteBytes, LPVOID *lplpvAudioPtr1,  LPDWORD lpdwAudioBytes1,  LPVOID *lplpvAudioPtr2,  LPDWORD lpdwAudioBytes2, DWORD dwFlags) PURE;
    STDMETHOD(Play)                 (THIS_ DWORD dwReserved1, DWORD dwPriority,  DWORD dwFlags ) PURE;
    STDMETHOD(SetCurrentPosition)   (THIS_ DWORD dwNewPosition) PURE;
    STDMETHOD(SetFormat)            (THIS_ LPCWAVEFORMATEX lpcfxFormat ) PURE;
    STDMETHOD(SetVolume)            (THIS_ LONG lVolume ) PURE;
    STDMETHOD(SetPan)               (THIS_ LONG lPan ) PURE;
    STDMETHOD(SetFrequency)         (THIS_ DWORD dwFrequency ) PURE;
    STDMETHOD(Stop)                 (THIS) PURE;
    STDMETHOD(Unlock)               (THIS_ LPVOID lpvAudioPtr1, DWORD dwAudioBytes1,  LPVOID lpvAudioPtr2, DWORD dwAudioBytes2 ) PURE;
    STDMETHOD(Restore)              (THIS) PURE;
}; 

/* IDirectSoundBuffer Proxy Class
 * Generated By MPH-Generator
 */
class CDirectSoundBufferProxy: public IDirectSoundBuffer
{
private:
	IDirectSoundBuffer *m_lpOrig;
	LONG m_lAbsVol;
	LONG m_lGain;
public:
	CDirectSoundBufferProxy(IDirectSoundBuffer *lpOrig, LONG lAbsVol, LONG lGain): m_lpOrig(lpOrig), m_lAbsVol(lAbsVol), m_lGain(lGain) {}
	// IUnknown methods
	STDMETHODIMP QueryInterface(REFIID p1, LPVOID * p2) { return m_lpOrig->QueryInterface( p1, p2 ); }
	STDMETHODIMP_(ULONG) AddRef() { return m_lpOrig->AddRef(   ); }
	STDMETHODIMP_(ULONG) Release() { 
		ULONG uRet = m_lpOrig->Release();
		if (!uRet) delete this;
		return uRet;
	}
	// IDirectSoundBuffer methods
	STDMETHODIMP GetCaps(LPVOID p1) { return m_lpOrig->GetCaps(  p1 ); }
	STDMETHODIMP GetCurrentPosition(LPDWORD p1, LPDWORD p2) { return m_lpOrig->GetCurrentPosition( p1, p2 ); }
	STDMETHODIMP GetFormat(LPWAVEFORMATEX p1, DWORD p2, LPDWORD p3) { return m_lpOrig->GetFormat( p1, p2, p3 ); }
	STDMETHODIMP GetVolume(LPLONG p1)  { return m_lpOrig->GetVolume(p1); } 
	STDMETHODIMP GetPan(LPLONG p1) { return m_lpOrig->GetPan(  p1 ); }
	STDMETHODIMP GetFrequency(LPDWORD p1) { return m_lpOrig->GetFrequency(  p1 ); }
	STDMETHODIMP GetStatus(LPDWORD p1) { return m_lpOrig->GetStatus(  p1 ); }
	STDMETHODIMP Initialize(LPVOID p1, LPVOID p2) { return m_lpOrig->Initialize( p1, p2 ); }
	STDMETHODIMP Lock(DWORD p1, DWORD p2, LPVOID *p3, LPDWORD p4, LPVOID *p5, LPDWORD p6, DWORD p7) { return m_lpOrig->Lock( p1, p2, p3, p4, p5, p6, p7 ); }
	STDMETHODIMP Play(DWORD p1, DWORD p2, DWORD p3) { return m_lpOrig->Play( p1, p2, p3 ); }
	STDMETHODIMP SetCurrentPosition(DWORD p1) { return m_lpOrig->SetCurrentPosition(  p1 ); }
	STDMETHODIMP SetFormat(LPCWAVEFORMATEX p1) { return m_lpOrig->SetFormat(  p1 ); }
	STDMETHODIMP SetVolume(LONG p1) {
		// C{[̃tF[hAEgG~[g
		// floatɗ͎gȂ悤ɏ_ȉľŒ菬_gp
		long lVol = ((long(__stdcall *)(float))0x4181A0)(0.01f * 0.75f * (*(long*)(0x6E6B38 + 0x68)));
		long lModVol = min(0, ((m_lAbsVol != 1) ? m_lAbsVol : lVol) +  m_lGain);
		long lRatio  = (p1 == lVol && p1 == -10000) ? 0 : MulDiv(p1 + 10000, 10000, lVol + 10000);
		long lFinalVol = ::MulDiv(lModVol + 10000, lRatio, 10000) - 10000;
		return m_lpOrig->SetVolume(lFinalVol);
	} 
	STDMETHODIMP SetPan(LONG p1) { return m_lpOrig->SetPan(  p1 ); }
	STDMETHODIMP SetFrequency(DWORD p1) { return m_lpOrig->SetFrequency(  p1 ); }
	STDMETHODIMP Stop() { return m_lpOrig->Stop(   ); }
	STDMETHODIMP Unlock(LPVOID p1, DWORD p2, LPVOID p3, DWORD p4) { return m_lpOrig->Unlock( p1, p2, p3, p4 ); }
	STDMETHODIMP Restore() { return m_lpOrig->Restore(   ); }
};

static struct {
	LPCSTR lpName;
	LONG  lAbsVol;
	LONG  lGain;
} s_entries[] = {
	"sr", 1, 0,
	"op", 1, 0,
	"st00", 1, 0,
	"st01", 1, 0,
	"st02", 1, 0,
	"st03", 1, 0,
	"st04", 1, 0,
	"st05", 1, 0,
	"st06", 1, 0,
	"st07", 1, 0,
	"st08", 1, 0,
	"st09", 1, 0,
	"st10", 1, 0,
	"st11", 1, 0,
	"st12", 1, 0,
	"st13", 1, 0,
	"st14", 1, 0,
	"st15", 1, 0,
	"st16", 1, 0,
	"st17", 1, 0,
	"st18", 1, 0,
	"st19", 1, 0,
	"st20", 1, 0,
	"st21", 1, 0,
	"st22", 1, 0,
	"ta00", 1, 0,
	"ta01", 1, 0,
	"ta02", 1, 0,
	"ta03", 1, 0,
	"ta04", 1, 0,
	"ta05", 1, 0,
	"ta06", 1, 0,
	"ta07", 1, 0,
	"ta08", 1, 0,
};

void * operator new (size_t size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

void operator delete(void *p)
{
	HeapFree(GetProcessHeap(), 0, p);
}

int GetEntryIndex(LPCSTR lpEntryName)
{
	for(int i = 0; i < _countof(s_entries); ++i) {
		if((s_entries[i].lGain != 0 || s_entries[i].lAbsVol != 1)
			&&
		   StrStr(lpEntryName, s_entries[i].lpName)) {
			return i;
		}
	}
	return -1;
}

typedef struct SSWRArgs{
	DWORD unk;
	SWRSTR fname;
} SWRArgs,*LPSWRArgs;
static bool (__fastcall *CreateSoundObject)(LPSWRArgs arg);
bool __declspec(naked) __fastcall thunkECX2EAX_CreateSoundObject(LPSWRArgs lpArg){
__asm{
		mov eax , ecx;
		jmp CreateSoundObject;
}}

bool __fastcall OnCreateSoundObject(DWORD dArg){
	LPSWRArgs lpArg = (LPSWRArgs)dArg;
	int x = GetEntryIndex(lpArg->fname.operator char *());
	bool r;
	if(x < 0){
		return thunkECX2EAX_CreateSoundObject(lpArg);
	}
	r = thunkECX2EAX_CreateSoundObject(lpArg);
	if(r){
		long lVol = ((long(__stdcall *)(float))0x4181A0)(0.01f * 0.75f * (*(long*)(0x6E6B38 + 0x68)));
		IDirectSoundBuffer** lpDSB = (IDirectSoundBuffer**)(dArg+0x28);
		// bsO
		*lpDSB = new ::CDirectSoundBufferProxy(*lpDSB,
			s_entries[x].lAbsVol, s_entries[x].lGain);
		(*lpDSB)->SetVolume(lVol);
	}
	return r;
}

bool  __declspec(naked) __fastcall thunkEAX2ECX_CreateSoundObject(){
__asm{
		mov ecx , eax;
		jmp OnCreateSoundObject;
}}


BOOL HookHisouten(HMODULE hModule)
{
	char szProfilePath[1024 + MAX_PATH];
	GetModuleFileName(hModule, szProfilePath, 1024);
	PathRemoveFileSpec(szProfilePath);
	PathAppend(szProfilePath, "BGMGain.ini");

	HANDLE hHeap = GetProcessHeap();
	for(int i = 0; i < _countof(s_entries); ++i) {
		int tmp;
		tmp =
			GetPrivateProfileInt(s_entries[i].lpName, "AbsVol", 20000, szProfilePath);
		s_entries[i].lAbsVol = (tmp - 10000) <= 0 ? (tmp - 10000) : 1;
		s_entries[i].lGain =
			GetPrivateProfileInt(s_entries[i].lpName, "Gain", 0, szProfilePath);
		s_entries[i].lGain -=
			GetPrivateProfileInt(s_entries[i].lpName, "mGain", 0, szProfilePath);
	}

	DWORD dwOldProtect;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &dwOldProtect);
	*(DWORD*)&CreateSoundObject = TamperNearJmpOpr(0x00403D2B ,((DWORD)thunkEAX2ECX_CreateSoundObject));
                                  TamperNearJmpOpr(0x004042CB ,((DWORD)thunkEAX2ECX_CreateSoundObject));
	::VirtualProtect((PVOID)text_Offset, text_Size, dwOldProtect, &dwOldProtect);

	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	switch(fdwReason) {
	case DLL_PROCESS_ATTACH:
		DisableThreadLibraryCalls(hModule);
		return HookHisouten(hModule);
	}
	return TRUE;
}
